%{
#include "lib.h"
#include "corec.tab.h"

unsigned int lineNumber = 1;
%}

%option nounput
%option noyywrap

%%

[\n]           {lineNumber++;printf("\n");}

[/][/].* ;
"/""*"([^*]|"*"+[^*/])*"*"+"/" ;

prog          {printf("prog"); return prog;}
def           {printf("def"); return def;}
Main          {printf("Main"); return Main;}
Loc[[:space:]]*:          {printf("Loc"); return loc;}
Dom[[:space:]]*:          {printf("dom"); return dom;}
Rec[[:space:]]*:          {printf("rec"); return rec;}

in[[:space:]]*:           {printf("in"); return in;}
out[[:space:]]*:          {printf("out"); return out;}
inout[[:space:]]*:        {printf("inout"); return inout;}

print         {printf("print"); return print;}
printstr      {printf("printstr"); return printstr;}
read          {printf("read_f"); return read_f;}

"{"           {printf("left_curly_bracket"); return left_curly_bracket;}
"}"           {printf("right_curly_bracket"); return right_curly_bracket;}
"["           {printf("left_bracket"); return left_bracket;}
"]"           {printf("right_bracket"); return right_bracket;}
"("           {printf("left_parenthesis"); return left_parenthesis;}
")"           {printf("right_parenthesis"); return right_parenthesis;}
";"           {printf("semicolon"); return semicolon;}
","           {printf("comma"); return comma;}
"+="          {printf("plus_aff"); return plus_aff;}  
"-="          {printf("sub_aff"); return sub_aff;}  
"*="          {printf("mult_aff"); return mult_aff;}
"/="          {printf("div_aff"); return div_aff;}
"<<="         {printf("not_recognized_aff"); return not_recognized_aff;}
">>="         {printf("not_recognized_aff"); return not_recognized_aff;}
[%&\^\|]"="   {printf("not_recognized_aff"); return not_recognized_aff;}
"="           {printf("aff"); return aff;}
".."          {printf("double_period"); return double_period;}
in            {printf("in_dom"); return in_dom;}

\?            {printf("ternary_then"); return ternary_then;}
[\:]          {printf("ternary_else"); return ternary_else;}

"=="          {printf("equal"); return equal;}
">="          {printf("sup_equal"); return sup_equal;}
"<="          {printf("inf_equal"); return inf_equal;}
"<"           {printf("inf"); return inf;}
">"           {printf("sup"); return sup;}
"+"           {printf("plus"); return plus;}
"*"           {printf("mult"); return mult;}
"-"           {printf("sub"); return sub;}
"/"           {printf("divide"); return divide;}
"%"           {printf("mod"); return mod;}

[[:alpha:]][[:alnum:]]*                             {
                                                        if ( yyleng > 63 )
                                                            fprintf(stderr,"Error at line %u: Identifier '%s' too long (> 63), truncated.\n",lineNumber,yytext);
                                                        strncpy(yylval.strval,yytext,63);
                                                        yylval.strval[64] = '\0';
                                                        return ID1;
                                                    }
[0-9]*[[:alpha:]]+[[:alnum:]]*                      {
                                                        if ( yyleng > 63 )
                                                            fprintf(stderr,"Error at line %u: Identifier '%s' too long (> 63), truncated.\n",lineNumber,yytext);
                                                        strncpy(yylval.strval,yytext,63);
                                                        yylval.strval[64] = '\0';
                                                        return ID2;
                                                    }
["]([^"]|[\\]["])*["]   {
                            printf("chaine");
                            if ( yyleng > 1023 )
                                fprintf(stderr,"Error at line %u: Identifier '%s' too long (> 1023), truncated\n",lineNumber,yytext);
                            strncpy(yylval.strval,yytext,1023);
                            yylval.strval[1023] = '\0';
                            return chaine;
                        }
(([1-9][0-9]*)|0)[.](([0-9]*[1-9])|[0]+)        {printf("flottant"); yylval.floatval = atof(yytext); return flottant;}
[1-9][0-9]*|0                                   {printf("entier"); yylval.intval = atoi(yytext); return entier;}

[[:space:]] {printf(" ");}

. fprintf(stderr,"Error at line %u: '%d' is not recognized.\n",lineNumber,yytext[0]);

%%